front_end 0.1.9

  • README.md
  • Installing
  • Versions
  • 56

Front end for Dart #

This package provides a low-level API for use by compiler back ends that wish to implement the Dart language. It is intended for eventual use by dev_compiler, dart2js, and the Dart VM. In addition, it will share implementation details with the analyzer package--this will be accomplished by having the analyzer package import (and re-export) parts of this package's private implementation.

End-users should use the [dartanalyzer][analyzercli] command-line tool to analyze their Dart code.

Integrators that want to write tools that analyze Dart code should use the [analyzer] package.

Note: The APIs in this package are in an early state; developers should be careful about depending on this package. In particular, there is no semver contract for release versions of this package. Please depend directly on individual versions.

Use this package as a library

1. Depend on it

Add this to your package's pubspec.yaml file:


dependencies:
  front_end: ^0.1.9

2. Install it

You can install packages from the command line:

with pub:


$ pub get

Alternatively, your editor might support pub get. Check the docs for your editor to learn more.

Version Uploaded Documentation Archive
0.1.18 May 3, 2019 Go to the documentation of front_end 0.1.18 Download front_end 0.1.18 archive
0.1.17 Apr 24, 2019 Go to the documentation of front_end 0.1.17 Download front_end 0.1.17 archive
0.1.16 Apr 22, 2019 Go to the documentation of front_end 0.1.16 Download front_end 0.1.16 archive
0.1.15 Mar 21, 2019 Go to the documentation of front_end 0.1.15 Download front_end 0.1.15 archive
0.1.14 Mar 15, 2019 Go to the documentation of front_end 0.1.14 Download front_end 0.1.14 archive
0.1.13 Feb 28, 2019 Go to the documentation of front_end 0.1.13 Download front_end 0.1.13 archive
0.1.12 Feb 22, 2019 Go to the documentation of front_end 0.1.12 Download front_end 0.1.12 archive
0.1.11 Feb 12, 2019 Go to the documentation of front_end 0.1.11 Download front_end 0.1.11 archive
0.1.10 Jan 29, 2019 Go to the documentation of front_end 0.1.10 Download front_end 0.1.10 archive
0.1.9+1 Feb 1, 2019 Go to the documentation of front_end 0.1.9+1 Download front_end 0.1.9+1 archive

All 45 versions...

Popularity:
Describes how popular the package is relative to other packages. [more]
96
Health:
Code health derived from static analysis. [more]
0
Maintenance:
Reflects how tidy and up-to-date the package is. [more]
40
Overall:
Weighted score of the above. [more]
56
Learn more about scoring.

We analyzed this package on May 8, 2019, and provided a score, details, and suggestions below. Analysis was completed with status completed using:

  • Dart: 2.3.0
  • pana: 0.12.15

Platforms

Detected platforms:

Low code quality prevents platform classification.

Health issues and suggestions

Fix lib/src/fasta/testing/scanner_chain.dart. (-98.66 points)

Analysis of lib/src/fasta/testing/scanner_chain.dart failed with 15 errors, including:

line 7 col 8: Target of URI doesn't exist: 'package:testing/testing.dart'.

line 29 col 20: Classes can only extend other classes.

line 29 col 20: Undefined class 'Step'.

line 29 col 25: The name 'TestDescription' isn't a type so it can't be used as a type argument.

line 29 col 52: The name 'ChainContext' isn't a type so it can't be used as a type argument.

Fix lib/src/fasta/testing/kernel_chain.dart. (-96.85 points)

Analysis of lib/src/fasta/testing/kernel_chain.dart failed with 12 errors, 1 hint, including:

line 36 col 8: Target of URI doesn't exist: 'package:testing/testing.dart'.

line 73 col 12: The method 'pass' isn't defined for the class 'Print'.

line 102 col 16: The method 'pass' isn't defined for the class 'Verify'.

line 123 col 14: The method 'pass' isn't defined for the class 'TypeCheck'.

line 195 col 16: The method 'pass' isn't defined for the class 'MatchExpectation'.

Fix lib/src/fasta/kernel/kernel_expression_generator_impl.dart. (-36.44 points)

Analysis of lib/src/fasta/kernel/kernel_expression_generator_impl.dart reported 6 warnings, 29 hints, including:

line 305 col 8: Parameters can't override default values, this method overrides 'KernelExpressionGenerator.buildCompoundAssignment' where 'offset' has a different value.

line 315 col 8: Parameters can't override default values, this method overrides 'KernelExpressionGenerator.buildPrefixIncrement' where 'offset' has a different value.

line 321 col 8: Parameters can't override default values, this method overrides 'KernelExpressionGenerator.buildPostfixIncrement' where 'offset' has a different value.

line 375 col 8: Parameters can't override default values, this method overrides 'KernelExpressionGenerator.buildCompoundAssignment' where 'offset' has a different value.

line 385 col 8: Parameters can't override default values, this method overrides 'KernelExpressionGenerator.buildPrefixIncrement' where 'offset' has a different value.

Fix additional 77 files with analysis or formatting issues. (-272.55 points)

Additional issues in the following files:

  • lib/src/fasta/kernel/kernel_expression_generator.dart (1 warning, 18 hints)
  • lib/src/scanner/token.dart (137 hints)
  • lib/src/fasta/scanner/abstract_scanner.dart (35 hints)
  • lib/src/base/errors.dart (34 hints)
  • lib/src/fasta/kernel/body_builder.dart (30 hints)
  • lib/src/fasta/kernel/kernel_shadow_ast.dart (30 hints)
  • lib/src/fasta/kernel/expression_generator.dart (24 hints)
  • lib/src/fasta/scanner/array_based_scanner.dart (19 hints)
  • lib/src/fasta/scanner/token.dart (19 hints)
  • lib/src/fasta/parser/parser.dart (18 hints)
  • lib/src/scanner/reader.dart (18 hints)
  • lib/src/fasta/type_inference/type_inferrer.dart (12 hints)
  • lib/src/fasta/scanner/utf8_bytes_scanner.dart (11 hints)
  • lib/src/fasta/source/source_loader.dart (11 hints)
  • lib/src/fasta/kernel/type_algorithms.dart (10 hints)
  • lib/src/fasta/scope.dart (10 hints)
  • lib/src/fasta/util/link.dart (10 hints)
  • lib/src/scanner/errors.dart (9 hints)
  • lib/src/testing/compiler_common.dart (9 hints)
  • lib/src/fasta/parser/identifier_context.dart (7 hints)
  • lib/src/kernel_generator_impl.dart (7 hints)
  • lib/src/fasta/kernel/kernel_class_builder.dart (6 hints)
  • lib/src/base/library_info.dart (5 hints)
  • lib/src/fasta/kernel/kernel_library_builder.dart (5 hints)
  • lib/src/fasta/scanner/string_scanner.dart (5 hints)
  • lib/src/base/processed_options.dart (4 hints)
  • lib/src/base/syntactic_entity.dart (4 hints)
  • lib/src/fasta/builder/library_builder.dart (4 hints)
  • lib/src/fasta/incremental_compiler.dart (4 hints)
  • lib/src/fasta/scanner.dart (4 hints)
  • lib/src/fasta/source/source_library_builder.dart (4 hints)
  • lib/src/fasta/builder/class_builder.dart (3 hints)
  • lib/src/fasta/scanner/keyword_state.dart (3 hints)
  • lib/src/fasta/type_inference/type_schema_elimination.dart (3 hints)
  • lib/src/fasta/type_inference/type_schema_environment.dart (3 hints)
  • lib/src/scanner/interner.dart (3 hints)
  • lib/src/base/resolve_relative_uri.dart (2 hints)
  • lib/src/fasta/compiler_context.dart (2 hints)
  • lib/src/fasta/dill/dill_library_builder.dart (2 hints)
  • lib/src/fasta/fasta_codes.dart (2 hints)
  • lib/src/fasta/kernel/kernel_mixin_application_builder.dart (2 hints)
  • lib/src/fasta/kernel/kernel_procedure_builder.dart (2 hints)
  • lib/src/fasta/kernel/kernel_type_variable_builder.dart (2 hints)
  • lib/src/fasta/kernel/verifier.dart (2 hints)
  • lib/src/fasta/loader.dart (2 hints)
  • lib/src/fasta/parser/listener.dart (2 hints)
  • lib/src/fasta/source/diet_listener.dart (2 hints)
  • lib/src/fasta/type_inference/interface_resolver.dart (2 hints)
  • lib/src/fasta/util/link_implementation.dart (2 hints)
  • lib/src/api_prototype/file_system.dart (1 hint)
  • lib/src/api_prototype/standard_file_system.dart (1 hint)
  • lib/src/api_prototype/summary_generator.dart (1 hint)
  • lib/src/base/instrumentation.dart (1 hint)
  • lib/src/base/libraries_specification.dart (1 hint)
  • lib/src/compute_platform_binaries_location.dart (1 hint)
  • lib/src/fasta/builder/field_builder.dart (1 hint)
  • lib/src/fasta/builder/mixin_application_builder.dart (1 hint)
  • lib/src/fasta/builder/procedure_builder.dart (1 hint)
  • lib/src/fasta/dill/dill_class_builder.dart (1 hint)
  • lib/src/fasta/dill/dill_loader.dart (1 hint)
  • lib/src/fasta/get_dependencies.dart (1 hint)
  • lib/src/fasta/import.dart (1 hint)
  • lib/src/fasta/kernel/class_hierarchy_builder.dart (1 hint)
  • lib/src/fasta/kernel/expression_generator_helper.dart (1 hint)
  • lib/src/fasta/kernel/kernel_constants.dart (1 hint)
  • lib/src/fasta/kernel/kernel_field_builder.dart (1 hint)
  • lib/src/fasta/kernel/kernel_invalid_type_builder.dart (1 hint)
  • lib/src/fasta/kernel/kernel_target.dart (1 hint)
  • lib/src/fasta/kernel/utils.dart (1 hint)
  • lib/src/fasta/modifier.dart (1 hint)
  • lib/src/fasta/parser/type_info_impl.dart (1 hint)
  • lib/src/fasta/scanner/io.dart (1 hint)
  • lib/src/fasta/source/outline_builder.dart (1 hint)
  • lib/src/fasta/source/stack_listener.dart (1 hint)
  • lib/src/fasta/ticker.dart (1 hint)
  • lib/src/fasta/type_inference/type_schema.dart (1 hint)
  • lib/src/fasta/scanner/scanner_main.dart (Run dartfmt to format lib/src/fasta/scanner/scanner_main.dart.)

Maintenance issues and suggestions

Fix platform conflicts. (-20 points)

Low code quality prevents platform classification.

Provide a file named CHANGELOG.md. (-20 points)

Changelog entries help developers follow the progress of your package. See the example generated by stagehand.

The package description is too short. (-20 points)

Add more detail to the description field of pubspec.yaml. Use 60 to 180 characters to describe the package, what it does, and its target use case.

Dependencies

Package Constraint Resolved Available
Direct dependencies
Dart SDK >=2.1.0-dev.5.0 <3.0.0
charcode ^1.1.1 1.1.2
convert ^2.0.1 2.1.1
crypto ^2.0.2 2.0.6
kernel 0.3.9 0.3.9 0.3.18
meta ^1.1.1 1.1.7
package_config ^1.0.1 1.0.5
path ^1.3.9 1.6.2
source_span ^1.2.3 1.5.5
yaml ^2.1.12 2.1.15
Transitive dependencies
collection 1.14.11
string_scanner 1.0.4
term_glyph 1.1.0
typed_data 1.1.6
Dev dependencies
analyzer 0.34.2
args >=0.13.0 <2.0.0 1.5.1
build_integration
dart_style ^1.0.7
json_rpc_2 ^2.0.9
mockito ^2.0.2
stream_channel ^1.6.1
test ^1.3.4
test_reflective_loader ^0.1.0
web_socket_channel ^1.0.4